unit LieroSDK;
interface

{ ******************************** Types ******************************** }

type TWord=array[0..0]of Word;
     PWord=^TWord;
type TSingleArray=array[0..0]of Single;
     PSingleArray=^TSingleArray;
     TBinCall=procedure(T,W:Word;X,Y,VX,VY,PX,PY,CX,CY:Single;M:Word;E:PSingleArray);
type TGrxFont=array[0..255]of Word;
     PGrxFont=^TGrxFont;
type TPossibleKeys=(lkLeft,lkRight,lkJump,lkAimUp,lkAimDown,lkMod,lkShoot);
     THitProc=procedure(P,Q:Integer);
     TControllers=(pcNone,pcHuman,pcAI);
const MaxProj=4096;
      MaxPType=1024;
      MaxArms=14;
      MaxBonuses=7;
const MaxMem=32768;
      MaxProgs=1536;
type TOperand=packed record
      T:Word;
      V:LongInt;
     end;
     TCell=packed record
      O:Word;
      A,B,C:TOperand;
     end;
     TFixup=packed record
      T:Byte;
      I:string[28];
      A:Word;
     end;
type PDLSym=^TDLSym;
     TDLSym=record
      ID:DWord;
      Name:string;
      Offs:DWord;
      Size:DWord;
      Next:PDLSym;
     end;
     PDLLibrary=^TDLLibrary;
     TDLLibrary=record
      Name:string;
      Base,Size:DWord;
      Syms:PDLSym;
      UseN:LongInt;
      MemP:Pointer;
      Next:PDLLibrary;
     end;
const dleOK=0;      // everything is OK
      dleNOCOFF=1;  // not a COFF file
      dleBADREL=2;  // bad relocation type
      dleNOTRES=3;  // unresolved external reference
      dleNOSYM=4;   // no such global symbol
      dleNOLIB=5;   // no such loaded library
      dleSTRIP=6;   // some moron stripped the lib
      dleBADSEC=7;  // a section exists after the '.bss' one
const mkText=0; // just static text
      mkButton=1; // press Enter to activate
      mkSingle=2; // float slider, from 0 to 1
      mkInteger=3; // integer, constraints: 'min,max' ('1,100')
      mkString=4; // string
      mkFile=5; // choose file, constraints: 'mask' ('*.LEV')
      mkKey=6; // press key
      mkQuit=7; // quit function
      mkSlider1=8; // colored slider for worm 1
      mkSlider2=9; // colored slider for worm 2
      mkPlayer=10; // player kind
const meKey1Left=-2;
      meKey1Right=-3;
      meKey1Jump=-4;
      meKey1AimUp=-5;
      meKey1AimDown=-6;
      meKey1Mod=-7;
      meKey1Shoot=-8;
      meKey2Left=-9;
      meKey2Right=-10;
      meKey2Jump=-11;
      meKey2AimUp=-12;
      meKey2AimDown=-13;
      meKey2Mod=-14;
      meKey2Shoot=-15;
      meSubMenu=-16;
      meWormBounce=-17;
      meWormGravity=-18;
      meWaterWormGravity=-19;
      meWormFriction=-20;
      meStoneFriction=-21;
      meWalkSpeed=-22;
      meAirSpeed=-23;
      meJumpSpeed=-24;
      meAimSpeed=-25;
      meStepHeight=-26;
      meWormDigSize=-27;
      meWormDigRange=-28;
      meWormClimb=-29;
      meRopeGravity=-30;
      meRopeForce=-31;
      meMaxRopeForce=-32;
      meStdRopeLen=-33;
      meRopeChangeSpeed=-34;
      meWormAirInh=-35;
      mePoisonSpeed=-36;
      meWaterDecay=-37;
      meVolume=-38;
      mePoisoning=-39;
      meSuffocation=-40;
      meUniGravity=-41;
      meCoolDown=-42;
      meReload=-43;
      meBonusGravity=-44;
      meBonusBounce=-45;
      meBonusChance=-46;
      meBaitDamage=-47;
      meBaitChance=-48;
      meShowBonuses=-49;
      meBonusLife=-50;
      meLifeCount=-51;
      meFallDamage=-52;
      meSelTerrain=-53;
      meColor1R=-54;
      meColor1G=-55;
      meColor1B=-56;
      meColor2R=-57;
      meColor2G=-58;
      meColor2B=-59;
      mePlayer1=-60;
      mePlayer2=-61;
      mePlayer3=-62;
      mePlayer4=-63;
      meMachName=-64;
const ipxQueueSize=256;
type TQueryPacket=packed record
      ID:Byte; // = 00
      _:array[0..126]of Byte; // padding
     end;
     TServerPacket=packed record
      ID:Byte; // = 01
      Name:string[31]; // server name
      _:array[0..94]of Byte; // padding
     end;
     TConnectPacket=packed record
      ID:Byte; // = 02
      Serv:string[31]; // server name
      Name:string[31]; // client name
      _:array[0..62]of Byte; // padding
     end;
     TNegativePacket=packed record
      ID:Byte; // = 03
      _:array[0..126]of Byte; // padding
     end;
     TConfigPacket=packed record
      ID:Byte; // = 04
      Menu:string[7]; // menu name; if empty, then stop and unlock
      Line:Integer; // menu line
      Value:string[40]; // option value
      RandSeed:LongInt; // terrain seed
      _:array[0..71]of Byte; // padding
     end;
     TConfAckPacket=packed record
      ID:Byte; // = 05
      _:array[0..126]of Byte; // padding
     end;
     TWeaponPacket=packed record
      ID:Byte; // = 06
      Max:array[1..2]of Byte; // slot count
      Weapons:array[1..2,0..15]of Integer; // weapons
      RandSeed:LongInt; // worm placement seed
      _:array[0..56]of Byte; // padding
     end;
     TKeysPacket=packed record
      ID:Byte; // = 07
      Base:Byte; // WormBase
      Keys:array[1..2,TPossibleKeys]of Boolean; // keys
      Lock:Boolean; // lock
      Unlock:Boolean; // unlock
      RandSeed:LongInt; // valid only from server
      _:array[0..105]of Byte; // padding
     end;
const IDQueryPacket=0;
      IDServerPacket=1;
      IDConnectPacket=2;
      IDNegativePacket=3;
      IDConfigPacket=4;
      IDConfAckPacket=5;
      IDWeaponPacket=6;
      IDKeysPacket=7;
type TPakRecord=record
      Name:string;
      Offset:LongInt;
      Size:LongInt;
     end;
     TPakFile=record
      Handle:file;
      Name:string;
      Count:LongInt;
      Files:array[0..0]of TPakRecord;
     end;
     PPakFile=^TPakFile;
const MaxSmp=64;
type TNullProc=procedure;
type TIntTab=array[0..0]of Integer;
     PIntTab=^TIntTab;
const MaxWeapons=1024;

{ ******************************* Hooks ********************************* }

type TNoParamHook=procedure;
     TIntegerHook=procedure(V:Integer);
     TCircleHook=procedure(X,Y,R:Integer);
var hkTerrainToVirtual:TNoParamHook; external name 'U_HOOKS_HKTERRAINTOVIRTUAL';
    hkVirtualToScreen:TNoParamHook; external name 'U_HOOKS_HKVIRTUALTOSCREEN';
    hkPostLoadLevel:TNoParamHook; external name 'U_HOOKS_HKPOSTLOADLEVEL';
    hkAddToMenu:TIntegerHook; external name 'U_HOOKS_HKADDTOMENU';
    hkCreateMenu:TNoParamHook; external name 'U_HOOKS_HKCREATEMENU';
    hkOnDig:TCircleHook; external name 'U_HOOKS_HKONDIG';
    hkBonusDestroy:TIntegerHook; external name 'U_HOOKS_HKBONUSDESTROY';

{ ****************************** WpnSel ********************************* }

procedure wDisplaySelector(Sv:Boolean);

{ ******************************* Worms ********************************* }

procedure wPerformAI(W:Byte);
procedure wCreateWorm(W:Byte);
procedure wUpdatePos(W:Byte);
procedure wUpdateScreenPos(W:Byte);
procedure wLoadGraphics;
function HaveBonus(W,B:Byte):Boolean;

{ ****************************** Weapons ******************************** }

var vWeapons:array[0..MaxWeapons-1]of packed record
     N:string; // name
     LP,E:Word; // launch program, ENIAC projectile
     LN,EN,MN:string; // launch program name, ENIAC projectile name, menu name
     CR,RR,RD,EV:Single; // cooldown rate, reload rate, reload decrement, ENIAC velocity
     LS:Boolean; // laser sight
     DL1,DL2,DL3:string[63]; // description
     DPN:string[7]; // picture name
     DP:Word; // picture
    end; external name 'U_WEAPONS_VWEAPONS';
    kWeapons:Word; external name 'U_WEAPONS_KWEAPONS';
function wFindWeapon(N:string):Word;
function wLoadWeapon(X:Pointer):Word;
function wRandomWeapon:Word;
procedure wFixupWeapons;

{ ******************************* Water ********************************* }

var wWater:array[0..255]of Byte; external name 'TC__WATER$$_WWATER';
    wPoison:array[0..255]of Byte; external name 'TC__WATER$$_WPOISON';
    wCleanWater:array[0..255]of Byte; external name 'TC__WATER$$_WCLEANWATER';
    wStopper:array[0..255]of Byte; external name 'TC__WATER$$_WSTOPPER';
    wWaterCycle:Integer; external name 'U_WATER_WWATERCYCLE';
    wSuffCycle:Integer; external name 'U_WATER_WSUFFCYCLE';
    wPoisCycle:Integer; external name 'U_WATER_WPOISCYCLE';
procedure wFlowWater;
procedure wFlowWaterR;
procedure wFlowWaterL;
procedure wPoisonWater;
procedure wDrawWaterVH(VX,VY,RX,RY,SX,SY:LongInt);
procedure wDrawDryVH(VX,VY,RX,RY,SX,SY:LongInt);

{ ******************************* VRand ********************************* }

var VRandSeed:LongInt; external name 'U_VRAND_VRANDSEED';
procedure VRandomize;
function VRandom:Extended;
function VRandom(R:LongInt):LongInt;

{ ****************************** Vignette ******************************* }

procedure DoVignette;

{ ****************************** Terrain ******************************** }

var tTerrains:array[0..255]of record
     Name:string;
     APtr:Pointer;
    end; external name 'U_TERRAIN_TTERRAINS';
    tTerrNames:array[0..255]of record
     Name,Text:string;
    end; external name 'U_TERRAIN_TTERRNAMES';
    tGenerators:array[0..255]of record
     ID:string;
     Name:string;
     SMenu:string;
     Menu:Integer;
    end; external name 'U_TERRAIN_TGENERATORS';
    tCurrentName:string; external name 'U_TERRAIN_TCURRENTNAME';
    tLaunchName:string; external name 'U_TERRAIN_TLAUNCHNAME';
    tTerrainSeed:LongInt; external name 'U_TERRAIN_TTERRAINSEED';
    tNoAutoBonus:Boolean; external name 'U_TERRAIN_TNOAUTOBONUS';
procedure tLoadGenerator(P:Pointer;N:string);
procedure tFixupGenerators;
procedure tLoadTerrain(P:Pointer;N:string);
procedure tLoadText(H:Pointer;N:string);
function tGetText(N:string):string;
procedure tSetTerrain(N:string);
procedure tClearCircle(X,Y,R:Integer);
procedure tMakeWater(X,Y,R:Integer);
procedure tMakePoison(X,Y,R:Integer);
procedure tMakeDirt(X,Y,R:Integer);
procedure tRemoveWater(X,Y,R:Integer);
procedure tMakeBlood(X,Y:Integer);
procedure tMakeAsh(X,Y:Integer);
procedure tMakeGround;
procedure tMakeAir(L:Integer);

{ ****************************** StrList ******************************** }

var sStrings:array[0..2047]of string; external name 'U_STRLIST_SSTRINGS';
    sNumStr:Integer; external name 'U_STRLIST_SNUMSTR';
    sLists:array[0..511]of record
     Name:string;
     Index:Integer;
    end; external name 'U_STRLIST_SLISTS';
    sString:string; external name 'U_STRLIST_SSTRING';
    sSingle:Single; external name 'U_STRLIST_SSINGLE';
    sLocale:Integer; external name 'U_STRLIST_SLOCALE';
procedure sLoadList(H:Pointer;N:string);
function sFindList(N:string):Integer;
function sGetStr(L,I:Integer):string;

{ ******************************* States ******************************** }

procedure sSaveState(FileName:string);
procedure sLoadState(FileName:string);
procedure sLoadKernelState(P:Pointer);
procedure sLoadMenuState(P:Pointer;N:string);

{ ******************************* Sound ********************************* }

var sSounds:array[0..1023]of record
     N:string[8];
     S:PIntTab;
     L:LongInt;
    end; external name 'U_SOUND_SSOUNDS';
function sFindSound(N:string):Integer;
function sLoadSound8(P:Pointer;N:string):Integer;
function sLoadSound16(P:Pointer;N:string):Integer;
procedure sPlaySound(H,P,V:Integer);

{ ******************************* SList ********************************* }

function slDisplayServers:Boolean;

{ ****************************** SBlaster ******************************* }

var sbRate:Word; external name 'TC__SBLASTER$$_SBRATE';
    sbVolume:Byte; external name 'TC__SBLASTER$$_SBVOLUME';
    sbMixerRate:Integer; external name 'TC__SBLASTER$$_SBMIXERRATE';
    sbOnMixer:TNullProc; external name 'TC__SBLASTER$$_SBONMIXER';
    sbBufSize:Word; external name 'U_SBLASTER_SBBUFSIZE';
    sbRunning:Boolean; external name 'U_SBLASTER_SBRUNNING';
    sbTiming:Boolean; external name 'U_SBLASTER_SBTIMING';
    sbStatus:Boolean; external name 'U_SBLASTER_SBSTATUS';
procedure sbInit;
function sbAddSample(S:Pointer;L:LongInt):Byte;
function sbAddSampleEx(S:Pointer;L,F,G:LongInt;R:Boolean):Byte;
procedure sbSetPan(H:Byte;P:Integer);
procedure sbSetVol(H:Byte;V:Byte);
procedure sbSetSpeed(H:Byte;F:LongInt);
function sbPosition(H:Byte):LongInt;
procedure sbKillSample(H:Byte);
procedure sbSetOffset(H:Byte;O:LongInt);
function sbPlaying:Byte;
function sbIsPlaying(H:Byte):Boolean;
procedure sbSetMixerRate(R:Integer);
procedure sbDone;

{ ******************************* ReadPak ******************************* }

var pPakStat:LongInt; external name 'U_READPAK_PPAKSTAT';
function pOpen(Name:string):PPakFile;
function pRead(Pak:PPakFile;Name:string):Pointer;
procedure pClose(Pak:PPakFile);
procedure pLoadPal(Name:string);
procedure pLoadGfx(Name:string);
procedure pLoadPrj(Name:string);
procedure pLoadRef(Name:string);
procedure pLoadCfg(Name:string);
procedure pLoadAll;

{ ********************************* Pub ********************************* }

function w2hex(w:Word):string;
function b2hex(b:Byte):string;
function l2hex(l:LongInt):string;
function l2bin(l:LongInt):string;
function l2rbin(l:LongInt):string;
function hex2l(s:string):LongInt;
function l2dec(l:LongInt):string;
function dec2l(s:string):LongInt;
function dec2f(s:string):Single;

{ ******************************* Project ******************************* }

var pOverload:Boolean; external name 'U_PROJECT_POVERLOAD';
function pNewProjectile(SX,SY,VX,VY:Single;W,K:Integer):Integer;
procedure pSimulateProj(I:Integer);
procedure pSimulateProjs;
function pNewProjKind(T:string;G,B,A:Single;L:PWord;N:Integer;P:THitProc):Integer;
procedure pKillProjectile(K:Integer);
function pFindProjType(T:string):Word;
procedure pLoadProjType(X:Pointer;N:string);
procedure pKillProjectiles;

{ ******************************* Packets ******************************* }

var pkServers:array[0..15]of string[31]; external name 'U_PACKETS_PKSERVERS';
    pkServerCount:Integer; external name 'U_PACKETS_PKSERVERCOUNT';
procedure pkWaitClient;
procedure pkTransferConfig;
procedure pkQueryServers;
function pkTryConnect(S:string):Boolean;
procedure pkTransferWeapons;
procedure pkWaitWeapons;

{ ******************************** NdIPX ******************************** }

var ipxRunning:Boolean; external name 'U_NDIPX_IPXRUNNING';
    ipxFocus:Boolean; external name 'U_NDIPX_IPXFOCUS';
    ipxSocket:Word; external name 'TC__NDIPX$$_IPXSOCKET';
    ipxLength:Word; external name 'U_NDIPX_IPXLENGTH';
    ipxQueue:array[0..ipxQueueSize-1]of Pointer; external name 'U_NDIPX_IPXQUEUE';
    ipxQueueHead:Integer; external name 'U_NDIPX_IPXQUEUEHEAD';
    ipxQueueTail:Integer; external name 'U_NDIPX_IPXQUEUETAIL';
    ipxQueueFault:Boolean; external name 'U_NDIPX_IPXQUEUEFAULT';
procedure ipxOpen(L:Word);
procedure ipxSend(var P);
function ipxReceive(var P):Boolean;
procedure ipxReplyOn;
procedure ipxReplyOff;
procedure ipxFocusOn;
procedure ipxFocusOff;
procedure ipxClose;

{ ******************************** Menu ********************************* }

var mKeyTrans:array[0..127]of Char; external name 'TC__MENU$$_MKEYTRANS';
    mKeyNames:array[0..127]of string[7]; external name 'TC__MENU$$_MKEYNAMES';
    mLines:array[0..1023]of record
     N:string[40]; // property name
     K:Integer; // kind (mk* constant)
     V,C:string[40]; // property value, constraints
     EN:string[8]; // event name (or negative numeric value for kernel events)
     E:Integer; // event ID
     T:Boolean; // transferable
    end; external name 'U_MENU_MLINES';
    mMenus:array[0..511]of record
     N:string[8]; // menu name
     H:string[40]; // menu header
     S,L:Integer; // start line, length
     C:packed array[0..15]of Single; // context
    end; external name 'U_MENU_MMENUS';
    mModMenus:array[0..255]of string[7]; external name 'U_MENU_MMODMENUS';
    mLineCount:Integer; external name 'U_MENU_MLINECOUNT';
    mModCount:Integer; external name 'U_MENU_MMODCOUNT';
    mLightFont:PGrxFont; external name 'U_MENU_MLIGHTFONT';
    mBoldFont:PGrxFont; external name 'U_MENU_MBOLDFONT';
procedure mRunEvent(M,E,P:string);
procedure mRunLineEvent(M,P:string;L:Integer);
function mShowMenu(I:Integer):Integer;
procedure mLoadGraphics;
function mFindMenu(N:string):Integer;
function mLoadMenu(X:Pointer;N:string):Integer;
procedure mLoadModMenu(X:Pointer;N:string);
procedure mFixupMenus;
procedure mCreateWeaponMenu;
procedure mCreateTerrainMenu;

{ ******************************** LibDL ******************************** }

var dlLibs:PDLLibrary; external name 'U_LIBDL_DLLIBS';
    dlLibCount:Integer; external name 'U_LIBDL_DLLIBCOUNT';
    dlError:Integer; external name 'U_LIBDL_DLERROR';
    dlQuiet:Boolean; external name 'TC__LIBDL$$_DLQUIET';
function dlLoadLibrary(Name:string):PDLLibrary;
function dlLoadLibrary(Name:string;COFF:Pointer):PDLLibrary;
procedure dlUnloadLibrary(Lib:PDLLibrary);
procedure dlUnloadLibrary(Name:string);
function dlFindGlobalSymbol(Name:string):DWord;
function dlFindLibrary(Name:string):PDLLibrary;

{ ******************************** Laser ******************************** }

procedure lLaser(SX,SY,VX,VY:Single;LP,TH,WH,W,S,M:Word;E:PSingleArray);

{ ******************************** LAIP ********************************* }

var lMemory:array[0..MaxMem-1]of TCell; external name 'U_LAIP_LMEMORY';
    lProgs:array[0..MaxProgs-1]of record
     N:string;
     A,L:LongInt;
    end; external name 'U_LAIP_LPROGS';
    lMemTop:LongInt; external name 'U_LAIP_LMEMTOP';
    lNProg:LongInt; external name 'U_LAIP_LNPROG';
    lSenH:Boolean; external name 'U_LAIP_LSENH';
    lSenV:Boolean; external name 'U_LAIP_LSENV';
function lFindProgram(N:string):Word;
procedure lLoadProgram(X:Pointer;N:string);
procedure lFixupProgram(X:Pointer;N:string);
procedure lRunProgram(P:Word;T,W:Word;X,Y,VX,VY,PX,PY,CX,CY:Single;M:Word;E:PSingleArray);

{ ******************************* iTimer ******************************** }

var iTimerFlag:Boolean; external name 'U_ITIMER_ITIMERFLAG';
    iTimerCount:LongInt; external name 'U_ITIMER_ITIMERCOUNT';
procedure iTimerInit;
procedure iTimerWait;

{ ******************************* iKeybd ******************************** }

var iKeys:array[0..511]of Boolean; external name 'U_IKEYBD_IKEYS';
function iKeyPressed:Boolean;
function iWaitKey:Byte;
function iReadKey:Byte;

{ ******************************** HRInt ******************************** }

var HRInter:array[0..511]of Byte; external name 'TC__HRINT$$_HRINTER';

{ ******************************* Grx13h ******************************** }

var gSprCnt:Word; external name 'U_GRX13H_GSPRCNT';
    gSprX:LongInt; external name 'U_GRX13H_GSPRX';
    gSprY:LongInt; external name 'U_GRX13H_GSPRY';
    gSprH:LongInt; external name 'U_GRX13H_GSPRH';
    gLineWidth:LongInt; external name 'U_GRX13H_GLINEWIDTH';
    gHSprX:LongInt; external name 'U_GRX13H_GHSPRX';
    gHSprY:LongInt; external name 'U_GRX13H_GHSPRY';
    gHSprH:LongInt; external name 'U_GRX13H_GHSPRH';
    gVS:Pointer; external name 'U_GRX13H_GVS';
    gHS:Pointer; external name 'U_GRX13H_GHS';
    gSpr:array[0..4095]of record N:string[8]; X,Y,HX,HY,HT:Word; SX,SY,RX,RY,T:Byte; end; external name 'U_GRX13H_GSPR';
    gPal:array[0..255,0..2]of Byte; external name 'U_GRX13H_GPAL';
    gHiRes:Boolean; external name 'TC__GRX13H$$_GHIRES';
    Pal16:packed array[0..255]of Word; external name 'U_GRX13H_PAL16';
procedure gInit;
procedure gPutPixel(X,Y:LongInt;C:Byte);
procedure gPutPixelH(X,Y:LongInt;C:Word);
function gGetPixel(X,Y:LongInt):Byte;
function gGetPixelH(X,Y:LongInt):Word;
procedure gDrawLine(X1,Y1,X2,Y2:LongInt;C:Word); // C is hi:lo
procedure gDrawLineH(X1,Y1,X2,Y2:LongInt;C:DWord); // C is hihi:lolo
procedure gSetPalette(P:Pointer);
function gGetVirtual(X,Y:LongInt):Pointer;
procedure gDone;
procedure gCopyWinVS(VX,VY,RX,RY,SX,SY:LongInt);
procedure gCopyWinHS(VX,VY,RX,RY,SX,SY:LongInt);
procedure gCopyWinVH(VX,VY,RX,RY,SX,SY:LongInt);
procedure gCopyWinVV(VX,VY,RX,RY,SX,SY:LongInt);
procedure gCopyWinHH(VX,VY,RX,RY,SX,SY:LongInt);
procedure gDownsampleWinVV(VX,VY,RX,RY,SX,SY,K:LongInt);
procedure gDownsampleWinHH(VX,VY,RX,RY,SX,SY,K:LongInt);
procedure gOverlayWinHH(VX,VY,RX,RY,SX,SY:LongInt;T:Word);
procedure gOverlayWinVV(VX,VY,RX,RY,SX,SY:LongInt;T:Byte);
procedure gOverlayWinHHX(VX,VY,RX,RY,SX,SY:LongInt;T:Word);
procedure gOverlayWinVVX(VX,VY,RX,RY,SX,SY:LongInt;T:Byte;M:Pointer);
procedure gSubstWinHH(VX,VY,RX,RY,SX,SY:LongInt;T,M,C:Word);
procedure gSubstWinVV(VX,VY,RX,RY,SX,SY:LongInt;T,M,C:Byte);
procedure gMaskWinHH(VX,VY,RX,RY,SX,SY:LongInt;T,C:Word);
procedure gMaskWinVV(VX,VY,RX,RY,SX,SY:LongInt;T,C:Byte);
procedure gFillWinV(RX,RY,SX,SY:LongInt;C:Byte);
procedure gFillWinH(RX,RY,SX,SY:LongInt;C:Word);
procedure gxDecWinV(RX,RY,SX,SY:LongInt);
function gTestCollision(VX,VY,RX,RY,SX,SY:LongInt;T:Byte;M:Pointer):Byte;
function gTestSprite(X,Y:LongInt;H:Word;var M):Byte;
function gNewSprite(S:Pointer;H:Boolean;N:string):Word;
procedure gPutMaskH(X,Y:LongInt;H:Word;C:Word);
procedure gPutMaskV(X,Y:LongInt;H:Word;C:Byte);
procedure gPutSpriteH(X,Y:LongInt;H:Word);
procedure gPutSpriteV(X,Y:LongInt;H:Word);
procedure gPutSpriteHX(X,Y:LongInt;H:Word);
procedure gPutSpriteVX(X,Y:LongInt;H:Word;var M);
procedure gPutLetterH(X,Y:LongInt;H:Word;C:Word);
procedure gPutLetterV(X,Y:LongInt;H:Word;C:Byte);
function gLookupSprite(N:string):Word;
function gOpenFont(Name:string):PGrxFont;
procedure gPrintTextV(X,Y:LongInt;Str:string;Font:PGrxFont;C:Byte);
procedure gPrintTextH(X,Y:LongInt;Str:string;Font:PGrxFont;C:Word);
function gTextWidth(Str:string;Font:PGrxFont):LongInt;
function gTextHeight(Str:string;Font:PGrxFont):LongInt;
procedure gCloseFont(Font:PGrxFont);
function Least(A:Single):Integer;

{ ******************************* GameVars ****************************** }

var vMappedKeys:array[1..4,TPossibleKeys]of Boolean; external name 'U_GAMEVARS_VMAPPEDKEYS';
    vWormBase:Integer; external name 'U_GAMEVARS_VWORMBASE';
    vFrame:DWord; external name 'U_GAMEVARS_VFRAME';
    vMsgTexts:array[0..9]of string; external name 'U_GAMEVARS_VMSGTEXTS';
    vMsgTTLs:array[0..9]of Integer; external name 'U_GAMEVARS_VMSGTTLS';
    vBonuses:array[5..254]of record X,Y,VX,VY:Single; K:Word; F:Byte; L:LongInt; end; external name 'U_GAMEVARS_VBONUSES';
    vWorms:array[1..4]of record
     NA,LR:Integer; // number of arms, lives remaining
     X,Y,VX,VY,A,WX,WY,CX,CY,ACU,ACD:Single; // pos, speed, angle, weapon, origin, angle change speed
     LAX,LAY:Single; // accel
     F:ShortInt; // phase
     H,MH:Single; // health, max health
     MT:Integer; // move timer
     LK,RK,LD,RD,LC,RC:Boolean; // key stats
     KLT,RA:Boolean; // [jump] pressed, rope anchored
     RID,WA:Integer; // rope projectile ID, worm anchored
     RL:Single; // rope length
     BT:array[0..MaxBonuses-1]of Byte; // bonuses
     AW:array[0..MaxArms-1]of Word; // weaponry
     AS,AR:array[0..MaxArms-1]of Single; // cooldown state, reload state
     RS:array[0..MaxArms-1]of Boolean; // is reloading
     AT:Integer; // selected weapon
     LM:array[0..MaxArms-1,0..15]of Single; // local memory
     KLC,FC,BSC:Integer; // keyboard lock count, frag counter, blue screen count
     LSS:Boolean; // locked shoot on start
     AIM:array[0..1023]of Single; // AI local memory
    end; external name 'U_GAMEVARS_VWORMS';
    vProjs:array[0..MaxProj-1]of record
     X,Y,VX,VY,G,B,A:Single; // pos, speed, grav, bounce, air inheritance
     O,T:Byte; // owner, target
     K:Word; // kind
     L,F:LongInt; // lifetime, animation frame
     LM:array[0..15]of Single; // lcal memory
     Z:Boolean; // still alive
    end; external name 'U_GAMEVARS_VPROJS';
    vProjTypes:array[0..MaxPType-1]of record
     T:string; // name
     L:array[0..15]of Word; // look (sprites)
     N:ShortInt; // number of frames, -1 -> direction-dependent look
     G,B,A:Single; // gravity, bounciness, air inheritance
     P:THitProc; // called when projectile hits wall/bonus/worm
     HT,HB,HW,HE,HF,HC,HK:Word; // programs to call on TerrainHit, BonusHit, WormHit, TimeExceeded, Fly, Create, Killed
     TTL:Integer; // Time To Live
     FS,IP:Integer; // frameskip for animation, for Fly proc
     PC,SI:Boolean; // projectile collisions, stop when idle
    end; external name 'U_GAMEVARS_VPROJTYPES';
    vScreenPos:array[1..4]of record X,Y:Single; end; external name 'U_GAMEVARS_VSCREENPOS';
    vCloseupPos:array[1..4]of record X,Y:Single; end; external name 'U_GAMEVARS_VCLOSEUPPOS';
    eCloseupPos:array[1..4]of record X,Y:Single; end; external name 'U_GAMEVARS_ECLOSEUPPOS';
    vWormStat:array[1..2,1..4]of string[32]; external name 'U_GAMEVARS_VWORMSTAT';
    vWormCollisions:array[0..255]of Byte; external name 'TC__GAMEVARS$$_VWORMCOLLISIONS';
    vDiggable:array[0..255]of Byte; external name 'TC__GAMEVARS$$_VDIGGABLE';
    vAir:array[0..255]of Byte; external name 'TC__GAMEVARS$$_VAIR';
    vProjCollisions:array[0..255]of Byte; external name 'TC__GAMEVARS$$_VPROJCOLLISIONS';
    vWormBounce:Single; external name 'TC__GAMEVARS$$_VWORMBOUNCE';
    vWormGravity:Single; external name 'TC__GAMEVARS$$_VWORMGRAVITY';
    vWaterWormGravity:Single; external name 'TC__GAMEVARS$$_VWATERWORMGRAVITY';
    vWormFriction:Single; external name 'TC__GAMEVARS$$_VWORMFRICTION';
    vStoneFriction:Single; external name 'TC__GAMEVARS$$_VSTONEFRICTION';
    vWalkSpeed:Single; external name 'TC__GAMEVARS$$_VWALKSPEED';
    vAirSpeed:Single; external name 'TC__GAMEVARS$$_VAIRSPEED';
    vJumpSpeed:Single; external name 'TC__GAMEVARS$$_VJUMPSPEED';
    vAimSpeed:Single; external name 'TC__GAMEVARS$$_VAIMSPEED';
    vWormCreepTime:Integer; external name 'TC__GAMEVARS$$_VWORMCREEPTIME';
    vStepHeight:Integer; external name 'TC__GAMEVARS$$_VSTEPHEIGHT';
    vWormDigSize:Integer; external name 'TC__GAMEVARS$$_VWORMDIGSIZE';
    vWormDigRange:Integer; external name 'TC__GAMEVARS$$_VWORMDIGRANGE';
    vPaletteTime:Integer; external name 'TC__GAMEVARS$$_VPALETTETIME';
    vWormClimb:Single; external name 'TC__GAMEVARS$$_VWORMCLIMB';
    vRopeGravity:Single; external name 'TC__GAMEVARS$$_VROPEGRAVITY';
    vRopeForce:Single; external name 'TC__GAMEVARS$$_VROPEFORCE';
    vMaxRopeForce:Single; external name 'TC__GAMEVARS$$_VMAXROPEFORCE';
    vStdRopeLen:Single; external name 'TC__GAMEVARS$$_VSTDROPELEN';
    vRopeChangeSpeed:Single; external name 'TC__GAMEVARS$$_VROPECHANGESPEED';
    vPoisonSpeed:Integer; external name 'TC__GAMEVARS$$_VPOISONSPEED';
    vWaterDecay:Integer; external name 'TC__GAMEVARS$$_VWATERDECAY';
    vSuffocation:Integer; external name 'TC__GAMEVARS$$_VSUFFOCATION';
    vPoisoning:Integer; external name 'TC__GAMEVARS$$_VPOISONING';
    vWormAirInh:Single; external name 'TC__GAMEVARS$$_VWORMAIRINH';
    vUniGravity:Single; external name 'TC__GAMEVARS$$_VUNIGRAVITY';
    vCoolDown:Single; external name 'TC__GAMEVARS$$_VCOOLDOWN';
    vReload:Single; external name 'TC__GAMEVARS$$_VRELOAD';
    vBonusGravity:Single; external name 'TC__GAMEVARS$$_VBONUSGRAVITY';
    vBonusBounce:Single; external name 'TC__GAMEVARS$$_VBONUSBOUNCE';
    vBonusChance:Single; external name 'TC__GAMEVARS$$_VBONUSCHANCE';
    vBonusLife:Integer; external name 'TC__GAMEVARS$$_VBONUSLIFE';
    vBaitDamage:Integer; external name 'TC__GAMEVARS$$_VBAITDAMAGE';
    vBaitChance:Single; external name 'TC__GAMEVARS$$_VBAITCHANCE';
    vShowBonuses:Boolean; external name 'TC__GAMEVARS$$_VSHOWBONUSES';
    vRegeneration:Integer; external name 'TC__GAMEVARS$$_VREGENERATION';
    vKickRadius:Single; external name 'TC__GAMEVARS$$_VKICKRADIUS';
    vKickForce:Single; external name 'TC__GAMEVARS$$_VKICKFORCE';
    vSplashThresh:Single; external name 'TC__GAMEVARS$$_VSPLASHTHRESH';
    vWormKeys:array[1..2,TPossibleKeys]of Byte; external name 'TC__GAMEVARS$$_VWORMKEYS';
    vWormWpnNum:array[1..2]of Integer; external name 'TC__GAMEVARS$$_VWORMWPNNUM';
    vLifeCount:Integer; external name 'TC__GAMEVARS$$_VLIFECOUNT';
    vFallDamage:Single; external name 'TC__GAMEVARS$$_VFALLDAMAGE';
    vPlayers:array[1..4]of TControllers; external name 'TC__GAMEVARS$$_VPLAYERS';
    vMachName:string[31]; external name 'TC__GAMEVARS$$_VMACHNAME';
    vWind:Single; external name 'TC__GAMEVARS$$_VWIND';
    vServing:Boolean; external name 'TC__GAMEVARS$$_VSERVING';
    vServingTo:string[31]; external name 'TC__GAMEVARS$$_VSERVINGTO';
    vClient:Boolean; external name 'TC__GAMEVARS$$_VCLIENT';
    vClientTo:string[31]; external name 'TC__GAMEVARS$$_VCLIENTTO';
var vWormWeapons:packed array[1..2,0..MaxArms-1]of string[39]; external name 'U_GAMEVARS_VWORMWEAPONS';
    vNonDiggable:array[0..255]of Byte; external name 'U_GAMEVARS_VNONDIGGABLE';
procedure vReinit;

{ ******************************* GameGrx ******************************* }

var xiCrate:Word; external name 'U_GAMEGRX_XICRATE';
    xiNewCrate:Word; external name 'U_GAMEGRX_XINEWCRATE';
    xiHealth:Word; external name 'U_GAMEGRX_XIHEALTH';
    xiAim:Word; external name 'U_GAMEGRX_XIAIM';
    xiHit:Word; external name 'U_GAMEGRX_XIHIT';
    xiAnchor:Word; external name 'U_GAMEGRX_XIANCHOR';
    xiToolBox:Word; external name 'U_GAMEGRX_XITOOLBOX';
    xiBonusBack:Word; external name 'U_GAMEGRX_XIBONUSBACK';
    xiBonuses:array[1..255]of Word; external name 'U_GAMEGRX_XIBONUSES';
    xiStars:array[1..5]of Word; external name 'U_GAMEGRX_XISTARS';
    xiExpl:array[1..16]of Word; external name 'U_GAMEGRX_XIEXPL';
    xiWorms:array[1..4,-3..3,0..16]of Word; external name 'U_GAMEGRX_XIWORMS';
    xiBigFont:PGrxFont; external name 'U_GAMEGRX_XIBIGFONT';
    xiSmallFont:PGrxFont; external name 'U_GAMEGRX_XISMALLFONT';
    xPalCounter:Integer; external name 'U_GAMEGRX_XPALCOUNTER';
    xDebugString:string; external name 'U_GAMEGRX_XDEBUGSTRING';
    xiInMenu:Boolean; external name 'U_GAMEGRX_XIINMENU';
    xiLastFPS:Single; external name 'U_GAMEGRX_XILASTFPS';
    xiFPS:Single; external name 'U_GAMEGRX_XIFPS';
    xiLastFrames:LongInt; external name 'U_GAMEGRX_XILASTFRAMES';
    AirOrDiggable:array[0..255]of Byte; external name 'U_GAMEGRX_AIRORDIGGABLE';
    CScreenPos:array[1..4]of record X,Y:Single; end; external name 'U_GAMEGRX_CSCREENPOS';
    CCloseupPos:array[1..4]of record X,Y:Integer; end; external name 'U_GAMEGRX_CCLOSEUPPOS';
procedure xLoadGraphics;
procedure xPaintBonus(I:Byte);
procedure xPaintWorm(I:Byte);
procedure xPaintWormShade(I:Byte);
procedure xPaintProj(I:Word);
procedure xPaintProjShade(I:Word);
procedure xPaintSprite(X,Y:LongInt;T:Word);
procedure xShowVirtual;
procedure xPaintAll;
procedure xCopyToScreen;
procedure xAddMessage(M:string);
procedure xRotatePalettes;
function xGetWormSprite(I:Byte):Word;
function xGetProjSprite(I:Word):Word;
function xGetBonusSprite(I:Byte):Word;
procedure xMapKeys;
procedure xPaintProjs;
procedure xFlagProjsRect(X1,Y1,W,H:Integer);

{ ******************************** ENIAC ******************************** }

var eCloseupX:Integer; external name 'U_ENIAC_ECLOSEUPX';
    eCloseupY:Integer; external name 'U_ENIAC_ECLOSEUPY';
function ePaintLaser(W:Byte):Boolean;
function ePaintENIAC(W:Byte):Boolean;
procedure eLoadImages;

{ ******************************* CopyRite ****************************** }

var cTable:array[0..255]of string; external name 'U_COPYRITE_CTABLE';
    cCount:Integer; external name 'U_COPYRITE_CCOUNT';
procedure cLoadCopyright(H:Pointer;N:string);

{ ******************************** Bonus ******************************** }

const bbInvisible=1;
      bbScubaGear=2;
      bbResistance=3;
      bbRegenerate=4;
      bbTeleport=5;
      bbArmorAP=6;
      bbTwinGuns=7;
      bbReload=8;
      bbStimPack=9;
      bbArmorSplash=10;
      bbKick=11;
      bbAvenger=12;
      bbGoodLuck=13;
      bbDigger=14;
      bbENIAC=15;
      bbSuperRope=16;
      bbMaxBonus=16;
var bAniCycle:Integer; external name 'U_BONUS_BANICYCLE';
procedure bCreateBonus;
procedure bNewBonus(X,Y,VX,VY:Single;K:Word);
procedure bAnimate;
procedure bKillBonuses;

{ ********************************* Air ********************************* }

var vAirVel:array[0..125,0..87]of record VX,VY,SD:Single; SO:Byte; end; external name 'U_AIR_VAIRVEL';
    nAirVel:array[0..125,0..87]of record VX,VY,SD:Single; SO:Byte; end; external name 'U_AIR_NAIRVEL';
procedure aExplode(X,Y,R:Integer;P:Single);
procedure aMakeFan(X,Y,R:Integer;VX,VY:Single);
procedure aAffect(D,X,Y:Single;var VX,VY:Single);
procedure aMakeWind(V:Single);
procedure aSplash(X,Y,R:Single;P:Single;O:Byte);
function aGetSplash(X,Y:Single;var O:Byte):Single;

implementation

{ ****************************** WpnSel ********************************* }

procedure wDisplaySelector(Sv:Boolean); external name '_WPNSEL$$_WDISPLAYSELECTOR$BOOLEAN';

{ ******************************* Worms ********************************* }

procedure wPerformAI(W:Byte); external name '_WORMS$$_WPERFORMAI$BYTE';
procedure wCreateWorm(W:Byte); external name '_WORMS$$_WCREATEWORM$BYTE';
procedure wUpdatePos(W:Byte); external name '_WORMS$$_WUPDATEPOS$BYTE';
procedure wUpdateScreenPos(W:Byte); external name '_WORMS$$_WUPDATESCREENPOS$BYTE';
procedure wLoadGraphics; external name '_WORMS$$_WLOADGRAPHICS';
function HaveBonus(W,B:Byte):Boolean; external name '_WORMS$$_HAVEBONUS$BYTE$BYTE';

{ ****************************** Weapons ******************************** }

function wFindWeapon(N:string):Word; external name '_WEAPONS$$_WFINDWEAPON$STRING';
function wLoadWeapon(X:Pointer):Word; external name '_WEAPONS$$_WLOADWEAPON$POINTER';
function wRandomWeapon:Word; external name '_WEAPONS$$_WRANDOMWEAPON';
procedure wFixupWeapons; external name '_WEAPONS$$_WFIXUPWEAPONS';

{ ******************************* Water ********************************* }

procedure wFlowWater; external name '_WATER$$_WFLOWWATER';
procedure wFlowWaterR; external name '_WATER$$_WFLOWWATERR';
procedure wFlowWaterL; external name '_WATER$$_WFLOWWATERL';
procedure wPoisonWater; external name '_WATER$$_WPOISONWATER';
procedure wDrawWaterVH(VX,VY,RX,RY,SX,SY:LongInt); external name '_WATER$$_WDRAWWATERVH$LONGINT$LONGINT$LONGINT$LONGINT$LONGINT$LONGINT';
procedure wDrawDryVH(VX,VY,RX,RY,SX,SY:LongInt); external name '_WATER$$_WDRAWDRYVH$LONGINT$LONGINT$LONGINT$LONGINT$LONGINT$LONGINT';

{ ******************************* VRand ********************************* }

procedure VRandomize; external name '_VRAND$$_VRANDOMIZE';
function VRandom:Extended; external name '_VRAND$$_VRANDOM';
function VRandom(R:LongInt):LongInt; external name '_VRAND$$_VRANDOM$LONGINT';

{ ***************************** Vignette ******************************** }

procedure DoVignette; external name '_VIGNETTE$$_DOVIGNETTE';

{ ****************************** Terrain ******************************** }

procedure tLoadGenerator(P:Pointer;N:string); external name '_TERRAIN$$_TLOADGENERATOR$POINTER$STRING';
procedure tFixupGenerators; external name '_TERRAIN$$_TFIXUPGENERATORS';
procedure tLoadTerrain(P:Pointer;N:string); external name '_TERRAIN$$_TLOADTERRAIN$POINTER$STRING';
procedure tLoadText(H:Pointer;N:string); external name '_TERRAIN$$_TLOADTEXT$POINTER$STRING';
function tGetText(N:string):string; external name '_TERRAIN$$_TGETTEXT$STRING';
procedure tSetTerrain(N:string); external name '_TERRAIN$$_TSETTERRAIN$STRING';
procedure tClearCircle(X,Y,R:Integer); external name '_TERRAIN$$_TCLEARCIRCLE$INTEGER$INTEGER$INTEGER';
procedure tMakeWater(X,Y,R:Integer); external name '_TERRAIN$$_TMAKEWATER$INTEGER$INTEGER$INTEGER';
procedure tMakePoison(X,Y,R:Integer); external name '_TERRAIN$$_TMAKEPOISON$INTEGER$INTEGER$INTEGER';
procedure tMakeDirt(X,Y,R:Integer); external name '_TERRAIN$$_TMAKEDIRT$INTEGER$INTEGER$INTEGER';
procedure tRemoveWater(X,Y,R:Integer); external name '_TERRAIN$$_TREMOVEWATER$INTEGER$INTEGER$INTEGER';
procedure tMakeBlood(X,Y:Integer); external name '_TERRAIN$$_TMAKEBLOOD$INTEGER$INTEGER';
procedure tMakeAsh(X,Y:Integer); external name '_TERRAIN$$_TMAKEASH$INTEGER$INTEGER';
procedure tMakeGround; external name '_TERRAIN$$_TMAKEGROUND';
procedure tMakeAir(L:Integer); external name '_TERRAIN$$_TMAKEAIR$INTEGER';

{ ****************************** StrList ******************************** }

procedure sLoadList(H:Pointer;N:string); external name '_STRLIST$$_SLOADLIST$POINTER$STRING';
function sFindList(N:string):Integer; external name '_STRLIST$$_SFINDLIST$STRING';
function sGetStr(L,I:Integer):string; external name '_STRLIST$$_SGETSTR$INTEGER$INTEGER';

{ ******************************* States ******************************** }

procedure sSaveState(FileName:string); external name '_STATES$$_SSAVESTATE$STRING';
procedure sLoadState(FileName:string); external name '_STATES$$_SLOADSTATE$STRING';
procedure sLoadKernelState(P:Pointer); external name '_STATES$$_SLOADKERNELSTATE$POINTER';
procedure sLoadMenuState(P:Pointer;N:string); external name '_STATES$$_SLOADMENUSTATE$POINTER$STRING';

{ ******************************* Sound ********************************* }

function sFindSound(N:string):Integer; external name '_SOUND$$_SFINDSOUND$STRING';
function sLoadSound8(P:Pointer;N:string):Integer; external name '_SOUND$$_SLOADSOUND8$POINTER$STRING';
function sLoadSound16(P:Pointer;N:string):Integer; external name '_SOUND$$_SLOADSOUND16$POINTER$STRING';
procedure sPlaySound(H,P,V:Integer); external name '_SOUND$$_SPLAYSOUND$INTEGER$INTEGER$INTEGER';

{ ******************************* SList ********************************* }

function slDisplayServers:Boolean; external name '_SLIST$$_SLDISPLAYSERVERS';

{ ****************************** SBlaster ******************************* }

procedure sbInit; external name '_SBLASTER$$_SBINIT';
function sbAddSample(S:Pointer;L:LongInt):Byte; external name '_SBLASTER$$_SBADDSAMPLE$POINTER$LONGINT';
function sbAddSampleEx(S:Pointer;L,F,G:LongInt;R:Boolean):Byte; external name '_SBLASTER$$_SBADDSAMPLEEX$POINTER$LONGINT$LONGINT$LONGINT$BOOLEAN';
procedure sbSetPan(H:Byte;P:Integer); external name '_SBLASTER$$_SBSETPAN$BYTE$INTEGER';
procedure sbSetVol(H:Byte;V:Byte); external name '_SBLASTER$$_SBSETVOL$BYTE$BYTE';
procedure sbSetSpeed(H:Byte;F:LongInt); external name '_SBLASTER$$_SBSETSPEED$BYTE$LONGINT';
function sbPosition(H:Byte):LongInt; external name '_SBLASTER$$_SBPOSITION$BYTE';
procedure sbKillSample(H:Byte); external name '_SBLASTER$$_SBKILLSAMPLE$BYTE';
procedure sbSetOffset(H:Byte;O:LongInt); external name '_SBLASTER$$_SBSETOFFSET$BYTE$LONGINT';
function sbPlaying:Byte; external name '_SBLASTER$$_SBPLAYING';
function sbIsPlaying(H:Byte):Boolean; external name '_SBLASTER$$_SBISPLAYING$BYTE';
procedure sbSetMixerRate(R:Integer); external name '_SBLASTER$$_SBSETMIXERRATE$INTEGER';
procedure sbDone; external name '_SBLASTER$$_SBDONE';

{ ******************************* ReadPak ******************************* }

function pOpen(Name:string):PPakFile; external name '_READPAK$$_POPEN$STRING';
function pRead(Pak:PPakFile;Name:string):Pointer; external name '_READPAK$$_PREAD$PPAKFILE$STRING';
procedure pClose(Pak:PPakFile); external name '_READPAK$$_PCLOSE$PPAKFILE';
procedure pLoadPal(Name:string); external name '_READPAK$$_PLOADPAL$STRING';
procedure pLoadGfx(Name:string); external name '_READPAK$$_PLOADGFX$STRING';
procedure pLoadPrj(Name:string); external name '_READPAK$$_PLOADPRJ$STRING';
procedure pLoadRef(Name:string); external name '_READPAK$$_PLOADREF$STRING';
procedure pLoadCfg(Name:string); external name '_READPAK$$_PLOADCFG$STRING';
procedure pLoadAll; external name '_READPAK$$_PLOADALL';

{ ********************************* Pub ********************************* }

function w2hex(w:Word):string; external name '_PUB$$_W2HEX$WORD';
function b2hex(b:Byte):string; external name '_PUB$$_B2HEX$BYTE';
function l2hex(l:LongInt):string; external name '_PUB$$_L2HEX$LONGINT';
function l2bin(l:LongInt):string; external name '_PUB$$_L2BIN$LONGINT';
function l2rbin(l:LongInt):string; external name '_PUB$$_L2RBIN$LONGINT';
function hex2l(s:string):LongInt; external name '_PUB$$_HEX2L$STRING';
function l2dec(l:LongInt):string; external name '_PUB$$_L2DEC$LONGINT';
function dec2l(s:string):LongInt; external name '_PUB$$_DEC2L$STRING';
function dec2f(s:string):Single; external name '_PUB$$_DEC2F$STRING';

{ ******************************* Project ******************************* }

function pNewProjectile(SX,SY,VX,VY:Single;W,K:Integer):Integer; external name '_PROJECT$$_PNEWPROJECTILE$SINGLE$SINGLE$SINGLE$SINGLE$INTEGER$INTEGER';
procedure pSimulateProj(I:Integer); external name '_PROJECT$$_PSIMULATEPROJ$INTEGER';
procedure pSimulateProjs; external name '_PROJECT$$_PSIMULATEPROJS';
function pNewProjKind(T:string;G,B,A:Single;L:PWord;N:Integer;P:THitProc):Integer; external name '_PROJECT$$_PNEWPROJKIND$STRING$SINGLE$SINGLE$SINGLE$PWORDARRAY$INTEGER$THITPROC';
procedure pKillProjectile(K:Integer); external name '_PROJECT$$_PKILLPROJECTILE$INTEGER';
function pFindProjType(T:string):Word; external name '_PROJECT$$_PFINDPROJTYPE$STRING';
procedure pLoadProjType(X:Pointer;N:string); external name '_PROJECT$$_PLOADPROJTYPE$POINTER$STRING';
procedure pKillProjectiles; external name '_PROJECT$$_PKILLPROJECTILES';

{ ******************************* Packets ******************************* }

procedure pkWaitClient; external name '_PACKETS$$_PKWAITCLIENT';
procedure pkTransferConfig; external name '_PACKETS$$_PKTRANSFERCONFIG';
procedure pkQueryServers; external name '_PACKETS$$_PKQUERYSERVERS';
function pkTryConnect(S:string):Boolean; external name '_PACKETS$$_PKTRYCONNECT$STRING';
procedure pkTransferWeapons; external name '_PACKETS$$_PKTRANSFERWEAPONS';
procedure pkWaitWeapons; external name '_PACKETS$$_PKWAITWEAPONS';

{ ******************************** NdIPX ******************************** }

procedure ipxOpen(L:Word); external name '_NDIPX$$_IPXOPEN$WORD';
procedure ipxSend(var P); external name '_NDIPX$$_IPXSEND$$$$';
function ipxReceive(var P):Boolean; external name '_NDIPX$$_IPXRECEIVE$$$$';
procedure ipxReplyOn; external name '_NDIPX$$_IPXREPLYON';
procedure ipxReplyOff; external name '_NDIPX$$_IPXREPLYOFF';
procedure ipxFocusOn; external name '_NDIPX$$_IPXFOCUSON';
procedure ipxFocusOff; external name '_NDIPX$$_IPXFOCUSOFF';
procedure ipxClose; external name '_NDIPX$$_IPXCLOSE';

{ ******************************** Menu ********************************* }

procedure mRunEvent(M,E,P:string); external name '_MENU$$_MRUNEVENT$STRING$STRING$STRING';
procedure mRunLineEvent(M,P:string;L:Integer); external name '_MENU$$_MRUNLINEEVENT$STRING$STRING$INTEGER';
function mShowMenu(I:Integer):Integer; external name '_MENU$$_MSHOWMENU$INTEGER';
procedure mLoadGraphics; external name '_MENU$$_MLOADGRAPHICS';
function mFindMenu(N:string):Integer; external name '_MENU$$_MFINDMENU$STRING';
function mLoadMenu(X:Pointer;N:string):Integer; external name '_MENU$$_MLOADMENU$POINTER$STRING';
procedure mLoadModMenu(X:Pointer;N:string); external name '_MENU$$_MLOADMODMENU$POINTER$STRING';
procedure mFixupMenus; external name '_MENU$$_MFIXUPMENUS';
procedure mCreateWeaponMenu; external name '_MENU$$_MCREATEWEAPONMENU';
procedure mCreateTerrainMenu; external name '_MENU$$_MCREATETERRAINMENU';

{ ******************************** LibDL ******************************** }

function dlLoadLibrary(Name:string):PDLLibrary; external name '_LIBDL$$_DLLOADLIBRARY$STRING';
function dlLoadLibrary(Name:string;COFF:Pointer):PDLLibrary; external name '_LIBDL$$_DLLOADLIBRARY$STRING$POINTER';
procedure dlUnloadLibrary(Lib:PDLLibrary); external name '_LIBDL$$_DLUNLOADLIBRARY$PDLLIBRARY';
procedure dlUnloadLibrary(Name:string); external name '_LIBDL$$_DLUNLOADLIBRARY$STRING';
function dlFindGlobalSymbol(Name:string):DWord; external name '_LIBDL$$_DLFINDGLOBALSYMBOL$STRING';
function dlFindLibrary(Name:string):PDLLibrary; external name '_LIBDL$$_DLFINDLIBRARY$STRING';

{ ******************************** Laser ******************************** }

procedure lLaser(SX,SY,VX,VY:Single;LP,TH,WH,W,S,M:Word;E:PSingleArray); external name '_LASER$$_LLASER$SINGLE$SINGLE$SINGLE$SINGLE$WORD$WORD$WORD$WORD$WORD$WORD$PSINGLEARRAY';

{ ******************************** LAIP ********************************* }

function lFindProgram(N:string):Word; external name '_LAIP$$_LFINDPROGRAM$STRING';
procedure lLoadProgram(X:Pointer;N:string); external name '_LAIP$$_LLOADPROGRAM$POINTER$STRING';
procedure lFixupProgram(X:Pointer;N:string); external name '_LAIP$$_LFIXUPPROGRAM$POINTER$STRING';
procedure lRunProgram(P:Word;T,W:Word;X,Y,VX,VY,PX,PY,CX,CY:Single;M:Word;E:PSingleArray); external name '_LAIP$$_LRUNPROGRAM$WORD$WORD$WORD$SINGLE$SINGLE$SINGLE$SINGLE$SINGLE$SINGLE$SINGLE$SINGLE$WORD$PSINGLEARRAY';

{ ******************************* iTimer ******************************** }

procedure iTimerInit; external name '_ITIMER$$_ITIMERINIT';
procedure iTimerWait; external name '_ITIMER$$_ITIMERWAIT';

{ ******************************* iKeybd ******************************** }

function iKeyPressed:Boolean; external name '_IKEYBD$$_IKEYPRESSED';
function iWaitKey:Byte; external name '_IKEYBD$$_IWAITKEY';
function iReadKey:Byte; external name '_IKEYBD$$_IREADKEY';

{ ******************************* Grx13h ******************************** }

procedure gInit; external name '_GRX13H$$_GINIT';
procedure gPutPixel(X,Y:LongInt;C:Byte); external name '_GRX13H$$_GPUTPIXEL$LONGINT$LONGINT$BYTE';
procedure gPutPixelH(X,Y:LongInt;C:Word); external name '_GRX13H$$_GPUTPIXELH$LONGINT$LONGINT$WORD';
function gGetPixel(X,Y:LongInt):Byte; external name '_GRX13H$$_GGETPIXEL$LONGINT$LONGINT';
function gGetPixelH(X,Y:LongInt):Word; external name '_GRX13H$$_GGETPIXELH$LONGINT$LONGINT';
procedure gDrawLine(X1,Y1,X2,Y2:LongInt;C:Word); external name '_GRX13H$$_GDRAWLINE$LONGINT$LONGINT$LONGINT$LONGINT$WORD';
procedure gDrawLineH(X1,Y1,X2,Y2:LongInt;C:DWord); external name '_GRX13H$$_GDRAWLINEH$LONGINT$LONGINT$LONGINT$LONGINT$DWORD';
procedure gSetPalette(P:Pointer); external name '_GRX13H$$_GSETPALETTE$POINTER';
function gGetVirtual(X,Y:LongInt):Pointer; external name '_GRX13H$$_GGETVIRTUAL$LONGINT$LONGINT';
procedure gDone; external name '_GRX13H$$_GDONE';
procedure gCopyWinVS(VX,VY,RX,RY,SX,SY:LongInt); external name '_GRX13H$$_GCOPYWINVS$LONGINT$LONGINT$LONGINT$LONGINT$LONGINT$LONGINT';
procedure gCopyWinHS(VX,VY,RX,RY,SX,SY:LongInt); external name '_GRX13H$$_GCOPYWINHS$LONGINT$LONGINT$LONGINT$LONGINT$LONGINT$LONGINT';
procedure gCopyWinVH(VX,VY,RX,RY,SX,SY:LongInt); external name '_GRX13H$$_GCOPYWINVH$LONGINT$LONGINT$LONGINT$LONGINT$LONGINT$LONGINT';
procedure gCopyWinVV(VX,VY,RX,RY,SX,SY:LongInt); external name '_GRX13H$$_GCOPYWINVV$LONGINT$LONGINT$LONGINT$LONGINT$LONGINT$LONGINT';
procedure gCopyWinHH(VX,VY,RX,RY,SX,SY:LongInt); external name '_GRX13H$$_GCOPYWINHH$LONGINT$LONGINT$LONGINT$LONGINT$LONGINT$LONGINT';
procedure gDownsampleWinVV(VX,VY,RX,RY,SX,SY,K:LongInt); external name '_GRX13H$$_GDOWNSAMPLEWINVV$LONGINT$LONGINT$LONGINT$LONGINT$LONGINT$LONGINT$LONGINT';
procedure gDownsampleWinHH(VX,VY,RX,RY,SX,SY,K:LongInt); external name '_GRX13H$$_GDOWNSAMPLEWINHH$LONGINT$LONGINT$LONGINT$LONGINT$LONGINT$LONGINT$LONGINT';
procedure gOverlayWinHH(VX,VY,RX,RY,SX,SY:LongInt;T:Word); external name '_GRX13H$$_GOVERLAYWINHH$LONGINT$LONGINT$LONGINT$LONGINT$LONGINT$LONGINT$WORD';
procedure gOverlayWinVV(VX,VY,RX,RY,SX,SY:LongInt;T:Byte); external name '_GRX13H$$_GOVERLAYWINVV$LONGINT$LONGINT$LONGINT$LONGINT$LONGINT$LONGINT$BYTE';
procedure gOverlayWinHHX(VX,VY,RX,RY,SX,SY:LongInt;T:Word); external name '_GRX13H$$_GOVERLAYWINHHX$LONGINT$LONGINT$LONGINT$LONGINT$LONGINT$LONGINT$WORD';
procedure gOverlayWinVVX(VX,VY,RX,RY,SX,SY:LongInt;T:Byte;M:Pointer); external name '_GRX13H$$_GOVERLAYWINVVX$LONGINT$LONGINT$LONGINT$LONGINT$LONGINT$LONGINT$BYTE$POINTER';
procedure gSubstWinHH(VX,VY,RX,RY,SX,SY:LongInt;T,M,C:Word); external name '_GRX13H$$_GSUBSTWINHH$LONGINT$LONGINT$LONGINT$LONGINT$LONGINT$LONGINT$WORD$WORD$WORD';
procedure gSubstWinVV(VX,VY,RX,RY,SX,SY:LongInt;T,M,C:Byte); external name '_GRX13H$$_GSUBSTWINVV$LONGINT$LONGINT$LONGINT$LONGINT$LONGINT$LONGINT$BYTE$BYTE$BYTE';
procedure gMaskWinHH(VX,VY,RX,RY,SX,SY:LongInt;T,C:Word); external name '_GRX13H$$_GMASKWINHH$LONGINT$LONGINT$LONGINT$LONGINT$LONGINT$LONGINT$WORD$WORD';
procedure gMaskWinVV(VX,VY,RX,RY,SX,SY:LongInt;T,C:Byte); external name '_GRX13H$$_GMASKWINVV$LONGINT$LONGINT$LONGINT$LONGINT$LONGINT$LONGINT$BYTE$BYTE';
procedure gFillWinV(RX,RY,SX,SY:LongInt;C:Byte); external name '_GRX13H$$_GFILLWINV$LONGINT$LONGINT$LONGINT$LONGINT$BYTE';
procedure gFillWinH(RX,RY,SX,SY:LongInt;C:Word); external name '_GRX13H$$_GFILLWINH$LONGINT$LONGINT$LONGINT$LONGINT$WORD';
procedure gxDecWinV(RX,RY,SX,SY:LongInt); external name '_GRX13H$$_GXDECWINV$LONGINT$LONGINT$LONGINT$LONGINT';
function gTestCollision(VX,VY,RX,RY,SX,SY:LongInt;T:Byte;M:Pointer):Byte; external name '_GRX13H$$_GTESTCOLLISION$LONGINT$LONGINT$LONGINT$LONGINT$LONGINT$LONGINT$BYTE$POINTER';
function gTestSprite(X,Y:LongInt;H:Word;var M):Byte; external name '_GRX13H$$_GTESTSPRITE$LONGINT$LONGINT$WORD$$$$';
function gNewSprite(S:Pointer;H:Boolean;N:string):Word; external name '_GRX13H$$_GNEWSPRITE$POINTER$BOOLEAN$STRING';
procedure gPutMaskH(X,Y:LongInt;H:Word;C:Word); external name '_GRX13H$$_GPUTMASKH$LONGINT$LONGINT$WORD$WORD';
procedure gPutMaskV(X,Y:LongInt;H:Word;C:Byte); external name '_GRX13H$$_GPUTMASKV$LONGINT$LONGINT$WORD$BYTE';
procedure gPutSpriteH(X,Y:LongInt;H:Word); external name '_GRX13H$$_GPUTSPRITEH$LONGINT$LONGINT$WORD';
procedure gPutSpriteV(X,Y:LongInt;H:Word); external name '_GRX13H$$_GPUTSPRITEV$LONGINT$LONGINT$WORD';
procedure gPutSpriteHX(X,Y:LongInt;H:Word); external name '_GRX13H$$_GPUTSPRITEHX$LONGINT$LONGINT$WORD';
procedure gPutSpriteVX(X,Y:LongInt;H:Word;var M); external name '_GRX13H$$_GPUTSPRITEVX$LONGINT$LONGINT$WORD$$$$';
procedure gPutLetterH(X,Y:LongInt;H:Word;C:Word); external name '_GRX13H$$_GPUTLETTERH$LONGINT$LONGINT$WORD$WORD';
procedure gPutLetterV(X,Y:LongInt;H:Word;C:Byte); external name '_GRX13H$$_GPUTLETTERV$LONGINT$LONGINT$WORD$BYTE';
function gLookupSprite(N:string):Word; external name '_GRX13H$$_GLOOKUPSPRITE$STRING';
function gOpenFont(Name:string):PGrxFont; external name '_GRX13H$$_GOPENFONT$STRING';
procedure gPrintTextV(X,Y:LongInt;Str:string;Font:PGrxFont;C:Byte); external name '_GRX13H$$_GPRINTTEXTV$LONGINT$LONGINT$STRING$PGRXFONT$BYTE';
procedure gPrintTextH(X,Y:LongInt;Str:string;Font:PGrxFont;C:Word); external name '_GRX13H$$_GPRINTTEXTH$LONGINT$LONGINT$STRING$PGRXFONT$WORD';
function gTextWidth(Str:string;Font:PGrxFont):LongInt; external name '_GRX13H$$_GTEXTWIDTH$STRING$PGRXFONT';
function gTextHeight(Str:string;Font:PGrxFont):LongInt; external name '_GRX13H$$_GTEXTHEIGHT$STRING$PGRXFONT';
procedure gCloseFont(Font:PGrxFont); external name '_GRX13H$$_GCLOSEFONT$PGRXFONT';
function Least(A:Single):Integer; external name '_GRX13H$$_LEAST$SINGLE';

{ ******************************* GameVars ****************************** }

procedure vReinit; external name '_GAMEVARS$$_VREINIT';

{ ******************************* GameGrx ******************************* }

procedure xLoadGraphics; external name '_GAMEGRX$$_XLOADGRAPHICS';
procedure xPaintBonus(I:Byte); external name '_GAMEGRX$$_XPAINTBONUS$BYTE';
procedure xPaintWorm(I:Byte); external name '_GAMEGRX$$_XPAINTWORM$BYTE';
procedure xPaintWormShade(I:Byte); external name '_GAMEGRX$$_XPAINTWORMSHADE$BYTE';
procedure xPaintProj(I:Word); external name '_GAMEGRX$$_XPAINTPROJ$WORD';
procedure xPaintProjShade(I:Word); external name '_GAMEGRX$$_XPAINTPROJSHADE$WORD';
procedure xPaintSprite(X,Y:LongInt;T:Word); external name '_GAMEGRX$$_XPAINTSPRITE$LONGINT$LONGINT$WORD';
procedure xShowVirtual; external name '_GAMEGRX$$_XSHOWVIRTUAL';
procedure xPaintAll; external name '_GAMEGRX$$_XPAINTALL';
procedure xCopyToScreen; external name '_GAMEGRX$$_XCOPYTOSCREEN';
procedure xAddMessage(M:string); external name '_GAMEGRX$$_XADDMESSAGE$STRING';
procedure xRotatePalettes; external name '_GAMEGRX$$_XROTATEPALETTES';
function xGetWormSprite(I:Byte):Word; external name '_GAMEGRX$$_XGETWORMSPRITE$BYTE';
function xGetProjSprite(I:Word):Word; external name '_GAMEGRX$$_XGETPROJSPRITE$WORD';
function xGetBonusSprite(I:Byte):Word; external name '_GAMEGRX$$_XGETBONUSSPRITE$BYTE';
procedure xMapKeys; external name '_GAMEGRX$$_XMAPKEYS';
procedure xPaintProjs; external name '_GAMEGRX$$_XPAINTPROJS';
procedure xFlagProjsRect(X1,Y1,W,H:Integer); external name '_GAMEGRX$$_XFLAGPROJSRECT$INTEGER$INTEGER$INTEGER$INTEGER';

{ ******************************** ENIAC ******************************** }

function ePaintLaser(W:Byte):Boolean; external name '_ENIAC$$_EPAINTLASER$BYTE';
function ePaintENIAC(W:Byte):Boolean; external name '_ENIAC$$_EPAINTENIAC$BYTE';
procedure eLoadImages; external name '_ENIAC$$_ELOADIMAGES';

{ ******************************* CopyRite ****************************** }

procedure cLoadCopyright(H:Pointer;N:string); external name '_COPYRITE$$_CLOADCOPYRIGHT$POINTER$STRING';

{ ******************************** Bonus ******************************** }

procedure bCreateBonus; external name '_BONUS$$_BCREATEBONUS';
procedure bNewBonus(X,Y,VX,VY:Single;K:Word); external name '_BONUS$$_BNEWBONUS$SINGLE$SINGLE$SINGLE$SINGLE$WORD';
procedure bAnimate; external name '_BONUS$$_BANIMATE';
procedure bKillBonuses; external name '_BONUS$$_BKILLBONUSES';

{ ********************************* Air ********************************* }

procedure aExplode(X,Y,R:Integer;P:Single); external name '_AIR$$_AEXPLODE$INTEGER$INTEGER$INTEGER$SINGLE';
procedure aMakeFan(X,Y,R:Integer;VX,VY:Single); external name '_AIR$$_AMAKEFAN$INTEGER$INTEGER$INTEGER$SINGLE$SINGLE';
procedure aAffect(D,X,Y:Single;var VX,VY:Single); external name '_AIR$$_AAFFECT$SINGLE$SINGLE$SINGLE$SINGLE$SINGLE';
procedure aMakeWind(V:Single); external name '_AIR$$_AMAKEWIND$SINGLE';
procedure aSplash(X,Y,R:Single;P:Single;O:Byte); external name '_AIR$$_ASPLASH$SINGLE$SINGLE$SINGLE$SINGLE$BYTE';
function aGetSplash(X,Y:Single;var O:Byte):Single; external name '_AIR$$_AGETSPLASH$SINGLE$SINGLE$BYTE';

end.
